this.tabtime=20;

this.checkShowCondition = function() {
	return 3*this.tabtime;
}

this.show = function() {	
	// switch tabs
	this.interval=setInterval(function() {
		var currentTab = $("#tabs").tabs('option', 'active');
		switch (currentTab) {
		case 0:
			currentTab = 1;
			break;
		case 1:
			currentTab = 2;
			break;
		case 2:
			currentTab = 0;
			break;
		default:
			currentTab = 0;
		}
		$("#tabs").tabs({
			active : currentTab
		});
	}, this.tabtime*1000);
}

this.hide = function() {
	clearInterval(this.interval);
}

function padTwo(num) {
	if (num < 10) {
		return "0" + num
	} else {
		return num
	}
}

function isNextDay() {
 	if (new Date().getHours() >= 15) {
		console.log("NEXT")
		return true;
	}
	console.log("CURRENT")
	return false;
}

function calcDateAPI() {
	if (isNextDay()) {
		return new Date().getFullYear() + "-" + padTwo(new Date().getMonth()+1) + "-" + (padTwo(new Date().getDate() + 1));
	} else {
		return new Date().getFullYear() + "-" + padTwo(new Date().getMonth()+1) + "-" + padTwo(new Date().getDate());
	}
}

function calcTextDisplay() {
	if (isNextDay()) {
                return "Mensaplan von MORGEN, dem  " + (padTwo(new Date().getDate() + 1)) +"."+ padTwo(new Date().getMonth()+1) +"."+ new Date().getFullYear();
        } else {
                return "Mensaplan von HEUTE, dem  " + padTwo(new Date().getDate()) +"."+ padTwo(new Date().getMonth()+1) +"."+ new Date().getFullYear();
        }
}

function handleGericht(text) {
	text = text.replace(/\([^\)]*\)/g, ""); // remove zusatzstoffe
	text = text.replace(/\s+/g, " "); // fix double Whitespace
	text = text.replace(/(\s,|,\s)/g, ","); // fix Komma
	text = text.replace(/,/g, ", "); // fix Komma
	text = text.replace(/,\sdazu\s\d\sBeilagen\snach\sWahl/g, " "); // remove Beilagen
	text = text.replace(/\sund\s\d\sBeilagen\snach\sWahl/g, " "); // remove Beilagen
	text = text.replace(/,\sdazu\s/g, " + "); // replace dazu
	text = text.replace(/\sund\s/g, " & "); // replace und
	return text
}

this.loaded = function(panel, config) {
	// reload data
	setInterval(function() {
		getMensaPlan();
	}, 30*60*1000);

	function getMensaPlan() {
		$.getJSON("https://infoscreen.oh14.de/canteen-menu/v3/canteens/341/"+calcDateAPI()).done(function(json) {
			fillTable(json);
		}).fail(function(jqxhr, textStatus, error) {
			var err = textStatus + ", " + error;
			console.error("MensaPlan: Request Failed: " + err);
		});
	}

	function fillTable(json) {
		document.getElementById("mensaPlanTitleBar").innerHTML = calcTextDisplay();
		var tableBody1 = document.getElementById("mensaPlanTable1Body");
		var tableBody3 = document.getElementById("mensaPlanTable3Body");
		var tableBody4 = document.getElementById("mensaPlanTable4Body");
		tableBody1.innerHTML = ""; // clear
		tableBody3.innerHTML = ""; // clear
		tableBody4.innerHTML = ""; // clear
		var a = 0;
		var b = 0;
		var c = 0;
		var d = 0;
		for (var i = 0; i < json.length; i++) {
			var gericht = json[i];
			var row = "";
			switch (gericht.category) {
			case "1": // Menu 1
				var row = tableBody1.insertRow(a);
				a++;
				var cell = row.insertCell(0);
				cell.innerHTML = handleGericht(gericht.title.de);
				break;
			case "2": // Menu 2
				var row = tableBody1.insertRow(a);
				a++;
				var cell = row.insertCell(0);
				cell.innerHTML = handleGericht(gericht.title.de);
				break;
			case "3": // Tagesgericht
				var row = tableBody1.insertRow(a);
				a++;
				var cell = row.insertCell(0);
				cell.innerHTML = handleGericht(gericht.title.de);
				break;
			case "4": // Vegetarisch
				var row = tableBody3.insertRow(c);
				c++;
				var cell = row.insertCell(0);
				cell.innerHTML = handleGericht(gericht.title.de);
				break;
			case "5": // Aktionsteller
				var row = tableBody1.insertRow(a);
				a++;
				var cell = row.insertCell(0);
				cell.innerHTML = handleGericht(gericht.title.de);
				break;
			case "6": // Aktionsteller Fisch
        var row = tableBody3.insertRow(c);
      	c++;
				var cell = row.insertCell(0);
				cell.innerHTML = handleGericht(gericht.title.de);
				break;
			case "7": // Aktionsteller Vegan
				var row = tableBody3.insertRow(c);
				c++;
				var cell = row.insertCell(0);
				cell.innerHTML = handleGericht(gericht.title.de);
				break;
			case "16": // Beilagen
				var beilagen = gericht.title.de.split(";");
				for (var j = 0; j < beilagen.length; j++) {
					if(beilagen[j] != "") {
						var row = tableBody4.insertRow(d);
						d++;
						var cell = row.insertCell(0);
						cell.innerHTML = handleGericht(beilagen[j]);
					}
				}
				break;
			default:
				var row = tableBody3.insertRow(c);
				c++;
				var cell = row.insertCell(0);
				cell.innerHTML = handleGericht(gericht.title.de);
			}
		}
	}

	getMensaPlan();

	$(function() {
		$("#tabs").tabs();
	});
}
